
class Z:
    BG         = 0.1
    ActorStart = 0.2
    Actor      = 0.5
    ActorEnd   = 0.8
    HUD        = 0.9
        
class Velocity:
    def __init__(self, x, y, height):
        self.x = x
        self.y = y
        self.height = height
        
class Context:
    def __init__(self, dt, input_layer):
        self.dt = dt
        self.input = input_layer
        self.gravity = 1000
        self.level = None
        self.audio = None
        
        self.rootnode = None
        
        self.actors_to_remove = []
        self.actors_to_add = []
        
    def getActorZ(self, actor):
        world_y = actor.getRealY()
        #if not (100 <= world_y <= 400):
        #    raise "outside world, dude::" + str(world_y)
        world_y = max( 100, min(400,world_y) )
        
        return ((400-world_y ) / 300.0) * (Z.ActorEnd-Z.ActorStart) + Z.ActorStart 
        
        
class Animation:
    def __init__(self, frames=2, delay = 0.1, loop=True):
        self.frames = frames
        self.delay = delay
        self.loop = loop
        
class ActorBuildData:
    def __init__(self):
        self.image = None
        self.pos = None
        self.height = 0 # flying height
        self.z = Z.Actor
        self.anim = None
        self.genes = None
        self.scale = 1.0
        self.rotation = 0.0
        self.state = None
        self.data = {}

