import math
import random

import cocos
from vec2d import Vec2d

from Context import ActorBuildData, Animation, Z
from Actors.Actor import Actor
from Actors.Bird import Bird
from Actors.Wolf import Wolf
from Actors.Egg import Egg

import Level

class Level03(Level.Level):
    def __init__(self, context):
        super(Level03, self).__init__()
        
        self.startTexts = []
        self.startTexts.append( "Impressive!" )
        self.startTexts.append( "The wolves are getting organized!" )
        self.startTexts.append( "They'll come in formation now, so" )
        self.startTexts.append( "if your birds can't fly, they'll be" )
        self.startTexts.append( "wolf-nommed in no-time!" )
        self.startTexts.append( "Earn 1000 coins for me." )
        self.startTexts.append( "If you pass this final test, I will" )
        self.startTexts.append( "donate the farm to you!" )

        self.initLabels(context)
        
        
        self.money = 400
        
        
        
        build_data = ActorBuildData()
        
        build_data.image = "farm01.png"
        build_data.pos = Vec2d(1200/2,720/2)
        build_data.z = Z.BG
        
        actor = Actor( context, build_data )
        self.add(actor)
        self.actors.append(actor)
        
        for x in range(3):
            build_data.pos = Vec2d(50+random.randint(0,600), 100 + random.randint(0,200))
            build_data.image = None
            self.createActor(Bird, context, build_data)
        
        self.t = -10000.0
        self.nextt = 1.0
        self.wcount = 0
        
    def start(self,context):
        super(Level03, self).start(context)
        
        self.t = 0.0

    def update(self, context):
        super(Level03, self).update(context)
        
        self.t += context.dt
        
        if self.t > self.nextt:
            self.t = 0
            self.nextt = 10 + random.random() * 50
            self.wcount += 1
            
            
            
            build_data = ActorBuildData()
            
            if self.wcount < 3:
                build_data.pos = Vec2d(-500, 150 + random.randint(0,200))
                self.createActor(Wolf, context, build_data)
        
            elif self.wcount < 6:
                y = 150 + random.randint(0,200)
                build_data.pos = Vec2d(-500, y)
                self.createActor(Wolf, context, build_data)
                build_data.pos = Vec2d(-500, y + 100)
                self.createActor(Wolf, context, build_data)
            else:
                for yy in range(4):
                    y = 100 + yy * 125
                    build_data.pos = Vec2d(-500, y)
                    self.createActor(Wolf, context, build_data)
        
        

    
    def isWon(self, context):
        return self.money > 1000
            
    def isLost(self, context):
        return self.money < 0
    
    
    